/* radec.c convert ra/dec/ha to hms, dms, hms */

#include <math.h>
#include "/usr2/fs/include/sexagesimal.h"

static convert();
static rnd();

radec(ra,dec,ha,rah,decd,hah)
double ra, dec, ha;
SEXAGESIMAL *rah,*decd,*hah;
{
      convert(ra*12./M_PI,rah);
      convert(dec*180./M_PI,decd);
      convert(ha*12./M_PI,hah);
}
static convert(ra, rah)
double ra;
SEXAGESIMAL *rah;
{
      if(ra <0.0)
        rah->sign='-';
      else
        rah->sign='+';

      ra  = fabs(ra);
      rah->ihours = ra;
      ra = ra - rah->ihours;

      rah->iminutes = ra*60.;
      ra = ra - rah->iminutes/60.;

      rah->seconds = ra*3600.0;
}
radecrnd(rah,decd,hah)
SEXAGESIMAL *rah,*decd,*hah;
{
       rnd(rah,59.95,24,'+');
       rnd(decd,59.5,90,' ');
       rnd(hah,59.95,90,'-');
}
static rnd(rah,round,limit,limits)
SEXAGESIMAL *rah;
float round;
int limit;
char limits;
{
      if(rah->seconds > round) {
        rah->seconds = 0.0;
        rah->iminutes++;
        if(rah->iminutes == 60) {
          rah->iminutes = 0;
          rah->ihours++;
          if(rah->ihours == limit && rah->sign == limits) {
            if(rah->sign == '-')
              rah->ihours = limit;
            else
              rah->ihours = 0;
          }
        }
      }
      return;
}
